% function analysisCrossValidation
clear
t_90margin_df4 = 2.1318;

%% display adaboost templates
iRun = 12;
load(sprintf('adaboostMAXC/out_adaboost_run%d.mat',iRun));
nF = 30;
towrite = displaySelectedFilters(ones(1,nF),selectedXs(1:nF),selectedYs(1:nF),selectedOs(1:nF),templateSize);
towrite = rgb2gray(towrite); 
towrite = towrite - min(towrite(:)); towrite = 255/max(towrite(:)) * towrite;
imwrite(towrite,'AdaboostMaxTemplate.png');

load(sprintf('adaboostMAXM/out_adaboost_run%d.mat',iRun));
nF = 30;
towrite = displaySelectedFilters(ones(1,nF),selectedXs(1:nF),selectedYs(1:nF),selectedOs(1:nF),templateSize);
towrite = rgb2gray(towrite); 
towrite = towrite - min(towrite(:)); towrite = 255/max(towrite(:)) * towrite;
imwrite(towrite,'AdaboostMaxTemplate_matlab.png');

load(sprintf('adaboostMAXC_limited/out_adaboost_run%d.mat',iRun));
nF = 30;
towrite = displaySelectedFilters(ones(1,nF),selectedXs(1:nF),selectedYs(1:nF),selectedOs(1:nF),templateSize);
towrite = rgb2gray(towrite); 
towrite = towrite - min(towrite(:)); towrite = 255/max(towrite(:)) * towrite;
imwrite(towrite,'AdaboostMaxTemplate_limited.png');

%% Plotting the AUC comparisons
nF = 80;

% run 1~5: 10 positive training examples
count = 1; 
auc10_adaboost = zeros(1,5);
auc10_limited = zeros(1,5);
auc10_matlab =zeros(1,5);
for iRun = 1:5
    load(sprintf('adaboostMAXC/out_adaboost_run%d.mat',iRun),'testAUC');
    auc10_adaboost(count) = testAUC(nF);
    load(sprintf('adaboostMAXC_limited/out_adaboost_run%d.mat',iRun),'testAUC');
    auc10_limited(count) = testAUC(nF);
    load(sprintf('adaboostMAXM/out_adaboost_run%d.mat',iRun),'testAUC');
    auc10_matlab(count) = testAUC(nF);
    count = count + 1;
end

% run 6~10: 20 positive training examples
count = 1; 
auc20_adaboost = zeros(1,5);
auc20_limited = zeros(1,5);
auc20_matlab =zeros(1,5);
for iRun = 6:10
    load(sprintf('adaboostMAXC/out_adaboost_run%d.mat',iRun),'testAUC');
    auc20_adaboost(count) = testAUC(nF);
    load(sprintf('adaboostMAXC_limited/out_adaboost_run%d.mat',iRun),'testAUC');
    auc20_limited(count) = testAUC(nF);
    load(sprintf('adaboostMAXM/out_adaboost_run%d.mat',iRun),'testAUC');
    auc20_matlab(count) = testAUC(nF);
    count = count + 1;
end

% run 11~15: 40 positive training examples
count = 1; 
auc40_adaboost = zeros(1,5);
auc40_limited = zeros(1,5);
auc40_matlab =zeros(1,5);
for iRun = 11:15
    load(sprintf('adaboostMAXC/out_adaboost_run%d.mat',iRun),'testAUC');
    auc40_adaboost(count) = testAUC(nF);
    load(sprintf('adaboostMAXC_limited/out_adaboost_run%d.mat',iRun),'testAUC');
    auc40_limited(count) = testAUC(nF);
    load(sprintf('adaboostMAXM/out_adaboost_run%d.mat',iRun),'testAUC');
    auc40_matlab(count) = testAUC(nF);
    count = count + 1;
end

% run 16~20: 80 positive training examples
count = 1; 
auc80_adaboost = zeros(1,5);
auc80_limited = zeros(1,5);
auc80_matlab =zeros(1,5);
for iRun = 16:20
    load(sprintf('adaboostMAXC/out_adaboost_run%d.mat',iRun),'testAUC');
    auc80_adaboost(count) = testAUC(nF);
    load(sprintf('adaboostMAXC_limited/out_adaboost_run%d.mat',iRun),'testAUC');
    auc80_limited(count) = testAUC(nF);
    load(sprintf('adaboostMAXM/out_adaboost_run%d.mat',iRun),'testAUC');
    auc80_matlab(count) = testAUC(nF);
    count = count + 1;
end

% run 21~25: 5 positive training examples
count = 1; 
auc5_adaboost = zeros(1,5);
auc5_limited = zeros(1,5);
auc5_matlab =zeros(1,5);
for iRun = 21:25
    load(sprintf('adaboostMAXC/out_adaboost_run%d.mat',iRun),'testAUC');
    auc5_adaboost(count) = testAUC(nF);
    load(sprintf('adaboostMAXC_limited/out_adaboost_run%d.mat',iRun),'testAUC');
    auc5_limited(count) = testAUC(nF);
    load(sprintf('adaboostMAXM/out_adaboost_run%d.mat',iRun),'testAUC');
    auc5_matlab(count) = testAUC(nF);
    count = count + 1;
end

curve1 = [mean(auc5_adaboost), mean(auc10_adaboost), mean(auc20_adaboost), mean(auc40_adaboost), mean(auc80_adaboost)];
err1 = [std(auc5_adaboost), std(auc10_adaboost), std(auc20_adaboost), std(auc40_adaboost), std(auc80_adaboost)];
err1 = err1 * t_90margin_df4 / sqrt(5);
curve2 = [mean(auc5_limited), mean(auc10_limited), mean(auc20_limited), mean(auc40_limited), mean(auc80_limited)];
err2 = [std(auc5_limited), std(auc10_limited), std(auc20_limited), std(auc40_limited), std(auc80_limited)];
err2 = err2 * t_90margin_df4 / sqrt(5);
curve3 = [mean(auc5_matlab), mean(auc10_matlab), mean(auc20_matlab), mean(auc40_matlab), mean(auc80_matlab)];
err3 = [std(auc5_matlab), std(auc10_matlab), std(auc20_matlab), std(auc40_matlab), std(auc80_matlab)];
err3 = err3 * t_90margin_df4 / sqrt(5);

% Plot the three curves of Test AUC
%   with 90% confidence bounds
figure;

h1 = errorbar([5,10,20,40,80],curve1,err1,'b-s','LineWidth',3);hold on 
h2 = errorbar([5,10,20,40,80],curve2,err2,'r-.','LineWidth',3);
h3 = errorbar([5,10,20,40,80],curve3,err3,'k-','LineWidth',2);


set(gca,'FontSize',12);
set(gca,'ylim',[0.90 1]);
set(gca,'xlim',[0 85]);
set(get(gca,'XLabel'),'String','# training positives','FontSize',18);
set(get(gca,'YLabel'),'String','testing AUC','FontSize',18);
legend([h1 h2 h3],{'full','limited','matlab'},'FontSize',16,0);
title('AUC vs. the number of positive training examples','FontSize',18);
set(gcf, 'PaperPositionMode', 'auto');
print -depsc adaboost_comparison.eps
print -dpng adaboost_comparison.png




